#include "defines.h"
#include "TPrgLine.h"
#include "TPrg.h"

void  err(int C, TPrgLine* P=NULL);
TPrg*  readFile(char*);
TPrg*  expand(TPrg*);
TPrg*  compact(TPrg*);

void   compile(TPrg*);

long int   bitPattern(TPrgLine*, int);

bool  isLabel(TPrg*, char*, int&);
bool  isCommand(char*,int&, int&, int&);
bool  isOperator(char*,int&);
bool  isRegister(char*,int&,int&);

int   ATOI(char*);
int   ATOI(const char*);

int   main(int, char**);

void  makeNOP(TPrgLine*);
void  makeNAF(TPrgLine*);
void  makeNAFX(TPrgLine*);
void  makeSPB(TPrgLine*);
void  makeBRU(TPrgLine*);
void  makeBRUR(TPrgLine*);
void  makeSKIP(TPrgLine*);
void  makeMOV(TPrgLine*);
void  makeINC(TPrgLine*);
void  makeDEC(TPrgLine*);
void  makeAND(TPrgLine*);
void  makeOR(TPrgLine*);
void  makeNOT(TPrgLine*);
void  makeRSH(TPrgLine*);
void  makeLSH(TPrgLine*);
void  makeMOD(TPrgLine*);
void  makeMUL(TPrgLine*);
void  makeDIV(TPrgLine*);
void  makeMERG(TPrgLine*);
void  makeOUT(TPrgLine*);
void  makePAR(TPrgLine*);
void  makeDLAY(TPrgLine*);
void  makeSETC(TPrgLine*);
void  makeCNAF(TPrgLine*);
void  makeIF(TPrgLine*);
void  makeROUT(TPrgLine*);
void  makeCROUT(TPrgLine*);
void  makeABORT(TPrgLine*);
void  makeRTRN(TPrgLine*);
void  makeEND(TPrgLine*);
void  makeINIT(TPrgLine*);
