// operators
#define O_ANY   0 
#define O_NONE  2  
#define O_GT    4  
#define O_LT    8  
#define O_GE    16  
#define O_LE    32 
#define O_NE    64 
#define O_EQ    128

// registers
#define R_PAT   1  
#define R_EXX   2  
#define R_CA    3 

// single commands
#define C_NOP     0x00000000
#define C_NAF     0x01000000
#define C_NAFX    0x02000000
#define C_SPB     0x03000000
#define C_BRU     0x04000000
#define C_BRUR    0x05000000
#define C_SKIP    0x06000000
#define C_MOV     0x07000000
#define C_MERG    0x08000000
#define C_OUT     0x09000000
#define C_PAR     0x0A000000
#define C_INC     0x0B000000
#define C_DEC     0x0C000000
#define C_DLAY    0x0D000000
#define C_SETC    0x0E000000
#define C_RTRN    0x0F000000
#define C_END     0x10000000
#define C_INIT    0x11000000
#define C_AND     0x12000000
#define C_OR      0x13000000
#define C_NOT     0x14000000
#define C_RSH     0x15000000
#define C_LSH     0x16000000
#define C_MOD     0x17000000
#define C_MUL     0x18000000
#define C_DIV     0x19000000
#define C_ABORT   0x1A000000

// macro commands
#define M_CNAF      0x100
#define M_CNAFX     0x101
#define M_IF        0x102
#define M_ROUT      0x103
#define M_CROUT     0x104
#define M_ROUTX     0x105
#define M_CROUTX    0x106
#define M_SPAT      0x107
#define M_CSPAT     0x108
